<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <h2 class="text-center">Danh sách đơn hàng</h2>
                <table class="table text-center table-striped" id="table-order">
                    <thead>
                        <tr>
                            <th scope="col">Order Code</th>
                            <th scope="col">Kích cỡ combo</th>
                            <th scope="col">Loại pizza</th>
                            <th scope="col">Nước uống</th>
                            <th scope="col">Thành tiền</th>
                            <th scope="col">Họ và tên</th>
                            <th scope="col">Số điện thoại</th>
                            <th scope="col">Trạng thái</th>
                            <th scope="col">Chi tiết</th>
                        </tr>
                    </thead>
                    <tbody>

                    </tbody>
                </table>
            </div>
        </div>
    </div>

    <script>
        "use strict";

        const gREQUEST_CREATE_SUCCESS = 201; // status 201 - tạo thành công
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_DELETE_SUCCESS = 204; // status 204 - Xóa thành công
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gORDERCODECELL = 0;
        const gKICHCOPIZZA = 1;
        const gLOAIPIZZA = 2;
        const gNUOCUONG = 3;
        const gTHANHTIEN = 4;
        const gHOTEN = 5;
        const gSODIENTHOAI = 6;
        const gTRANGTHAI = 7;
        const gCHITIET = 8;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
        

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        function onBtnDetailClick(paramBtnDetail){
            var vId = paramBtnDetail.dataset.id;
            var vOrderCode = paramBtnDetail.dataset.ordercode;
            console.log("ID : " + vId + " - OrderCode : "+ vOrderCode);
            var vUrl = "order-update.html?id=" + vId + "&orderCode=" + vOrderCode;
            window.location.href = vUrl;

        }

        
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
             /**
            * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
            */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                    var OrderList = vXmlHttpGetAllOrders.responseText;
                    console.log(OrderList);
                   
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {
            const vBaseUrl = "http://203.171.20.210:8080/devcamp-pizza365/orders";
            paramXMLHttpGetAllOrders.open("GET", vBaseUrl, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            var vAllOrderObj = JSON.parse(paramXMLHttpAllOrder.responseText);
            var vTableOrderList = document.getElementById("table-order");
            var vTableOrderListBody = vTableOrderList.getElementsByTagName("tbody")[0];
            for (var bIndex = 0 ; bIndex < vAllOrderObj.length ;bIndex++){
                var vThanhTien = parseInt(vAllOrderObj[bIndex].thanhTien) - parseInt(vAllOrderObj[bIndex].giamGia);
                var vNewRow = vTableOrderListBody.insertRow();
                var vNewCellOrderCode = vNewRow.insertCell(gORDERCODECELL);
                var vNewCellKichCoPizza = vNewRow.insertCell(gKICHCOPIZZA);
                var vNewCellLoaiPizza = vNewRow.insertCell(gLOAIPIZZA);
                var vNewCellNuocUong = vNewRow.insertCell(gNUOCUONG);
                var vNewCellThanhTien = vNewRow.insertCell(gTHANHTIEN);
                var vNewCellHoTen = vNewRow.insertCell(gHOTEN);
                var vNewCellSoDienThoai = vNewRow.insertCell(gSODIENTHOAI);
                var vNewCellTrangThai = vNewRow.insertCell(gTRANGTHAI);
                var vNewCellChiTiet = vNewRow.insertCell(gCHITIET);

                vNewCellOrderCode.innerHTML = vAllOrderObj[bIndex].orderCode;
                vNewCellKichCoPizza.innerHTML = vAllOrderObj[bIndex].kichCo;
                vNewCellLoaiPizza.innerHTML = vAllOrderObj[bIndex].loaiPizza;
                vNewCellNuocUong.innerHTML = vAllOrderObj[bIndex].idLoaiNuocUong;
                vNewCellThanhTien.innerHTML = vThanhTien;
                vNewCellHoTen.innerHTML = vAllOrderObj[bIndex].hoTen;
                vNewCellSoDienThoai.innerHTML = vAllOrderObj[bIndex].soDienThoai;
                vNewCellTrangThai.innerHTML = vAllOrderObj[bIndex].trangThai;

                var vButtonDetail = document.createElement("button");
                vButtonDetail.className = 'btn btn-info';
                vButtonDetail.innerHTML = 'Chi tiết';
                vButtonDetail.setAttribute('data-ordercode',vAllOrderObj[bIndex].orderCode);
                vButtonDetail.setAttribute('data-id',vAllOrderObj[bIndex].id);
                vButtonDetail.addEventListener('click',function(){
                    onBtnDetailClick(this);
                });
                vNewCellChiTiet.appendChild(vButtonDetail);

                


            }
        }
        
    </script>
</body>

</html>